library mousehook;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  View-Project Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the DELPHIMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using DELPHIMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  SysUtils,
  Classes,
  Windows,
  Forms, Messages;

type
   HOOKPROC = function (nCode:integer; wParam: WPARAM; lParam:LPARAM):LRESULT;stdcall;
  _MYHOOKDATA = record
    nType:integer;
    hkprc:HOOKPROC;
    hhook:HHOOK;
  end;

  MSG =record
    hwnd:HWND;
    message:UINT;
    wParam:WPARAM;
    lParam:LPARAM;
    time:DWORD;
    pt:TPOINT;
  end;

  EVENTMSGMSG =record
    message:UINT;
    paramL:UINT;
    paramH:UINT;
    time:DWORD;
    hwnd:HWND;
  end;

  MOUSEHOOKSTRUCT =record
    pt:TPOINT ;
    hwnd:HWND;
    wHitTestCode:UINT;
    dwExtraInfo:DWORD;
  end;

  _Mcallback = procedure (x,y:integer) of object;
  var myhookdata:_myhookdata;
      Mcallback : _Mcallback;

function MouseProc(nCode:integer; wParam: WPARAM; lParam:LPARAM):LRESULT;stdcall;
Begin
  if (nCode < 0) then
    result:=CallNextHookEx(myhookdata.hhook, nCode, wParam, lParam)
  else
  if (EVENTMSGMSG(Pointer(lParam)^).message = WM_MOUSEMOVE ) and assigned(Mcallback) then
  Begin
    Mcallback(EVENTMSGMSG(Pointer(lParam)^).paramL,EVENTMSGMSG(Pointer(lParam)^).paramh);
    result:=CallNextHookEx(myhookdata.hhook, nCode, wParam, lParam);
  End;
End;

function registerGlobalMouseCallBack(Acallback:_Mcallback):longint;
begin
  Mcallback:=Acallback;
  myhookdata.nType := WH_JOURNALRECORD;
  myhookdata.hkprc := MouseProc;
  result:=SetWindowsHookEx(myhookdata.nType, myhookdata.hkprc, HInstance, 0);
End;

function UnRegisterGlobalMouseCallBack:longBool;
Begin
  if assigned(Mcallback) then
  Begin
    Mcallback := nil;
    result:=UnhookWindowsHookEx(myhookdata.hhook);
  End
  else
    result:=false;
End;

exports MouseProc, registerGlobalMouseCallBack,UnRegisterGlobalMouseCallBack;

begin
end.
